Lang (Apache Commons Codec 1.22.1 API)
Description: declaration: package: org.apache.commons.codec.language.bm, class: Lang

Package org.apache.commons.codec.language.bm

# Class Lang

java.lang.Object
org.apache.commons.codec.language.bm.Lang

public class Lang extends Object
Language guessing utility.

This class encapsulates rules used to guess the possible languages that a word originates from. This is done by reference to a whole series of rules distributed in resource files.

Instances of this class are typically managed through the static factory method instance(). Unless you are developing your own language guessing rules, you will not need to interact with this class directly.

This class is intended to be immutable and thread-safe.

## Lang resources

Language guessing rules are typically loaded from resource files. These are UTF-8 encoded text files. They are systematically named following the pattern:

> org/apache/commons/codec/language/bm/lang.txt

The format of these resources is the following:

- Rules: whitespace separated strings. There should be 3 columns to each row, and these will be interpreted as:
  1. pattern: a regular expression.
  2. languages: a '+'-separated list of languages.
  3. acceptOnMatch: 'true' or 'false' indicating if a match rules in or rules out the language.
- End-of-line comments: Any occurrence of '//' will cause all text following on that line to be discarded as a comment.
- Multi-line comments: Any line starting with '/*' will start multi-line commenting mode. This will skip all content until a line ending in '*' and '/' is found.
- Blank lines: All blank lines will be skipped.

Port of lang.php

Since:
  1.6

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `guessLanguage(String text)`
  Guesses the language of a word.
  `Languages.LanguageSet`
  `guessLanguages(String input)`
  Guesses the languages of a word.
  `static Lang`
  `instance(NameType nameType)`
  Gets a Lang instance for one of the supported NameTypes.
  `static Lang`
  `loadFromResource(String languageRulesResourceName, Languages languages)`
  Loads language rules from a resource.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### instance

    public static Lang instance(NameType nameType)
    Gets a Lang instance for one of the supported NameTypes.
    Parameters:
      `nameType` - the NameType to look up.
    Returns:
      A Lang encapsulating the language guessing rules for that name type.

  - ### loadFromResource

    public static Lang loadFromResource(String languageRulesResourceName, Languages languages)
    Loads language rules from a resource.

    In normal use, you will obtain instances of Lang through the `instance(NameType)` method. You will only need to call this yourself if you are developing custom language mapping rules.

    Parameters:
      `languageRulesResourceName` - the fully-qualified resource name to load.
      `languages` - the languages that these rules will support.
    Returns:
      A Lang encapsulating the loaded language-guessing rules.

  - ### guessLanguage

    public String guessLanguage(String text)
    Guesses the language of a word.
    Parameters:
      `text` - the word.
    Returns:
      The language that the word originates from or `Languages.ANY` if there was no unique match.

  - ### guessLanguages

    public Languages.LanguageSet guessLanguages(String input)
    Guesses the languages of a word.
    Parameters:
      `input` - the word.
    Returns:
      A Set of Strings of language names that are potential matches for the input word.